OpenVDB: Value< std::string > Struct Reference

OpenVDB 13.0.0

Loading...
Searching...
No Matches
Value< std::string > Struct Reference

Specialization of Values for strings. More...

`#include <openvdb_ax/ast/AST.h>`

Inheritance diagram for Value< std::string >:

## Public Types
using | UniquePtr = std::unique_ptr<Value<std::string>>
using | Type = std::string
using | ContainerType
| Integers and Floats store their value as ContainerType, which is guaranteed to be at least large enough to represent the maximum possible supported type for the requested precision.
enum | NodeType
| An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType. More...
using | Ptr

## Public Member Functions
| Value (const Type &value)
| Construct a new Value string from a string.
| Value (const Value< Type > &other)
| Deep copy constructor for a Value string.
| ~Value () override=default
Value< Type > * | copy () const override final
| The deep copy method for a Node.
NodeType | nodetype () const override
| Virtual method for accessing node type information.
const char * | nodename () const override
| Virtual method for accessing node name information.
const char * | subname () const override
| Virtual method for accessing node name information.
const ValueBase * | basetype () const override
| Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.
const std::string & | value () const
| Access the string.
ContainerType | asContainerType () const
| Access the value as its stored type.
size_t | children () const override
| Virtual method for accessing child information. Returns the number of children a given AST node owns.
const Node * | child (const size_t) const override
| Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.
Name/Type
bool | isType () const
| Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().
Child Queries
int64_t | childidx () const
| Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).
Replacement
bool | replace (Node *node)
| In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.
virtual bool | replacechild (const size_t index, Node *node)
| Virtual method that attempted to replace a child at a given index with a provided node type.
Parent
const Node * | parent () const
| Access a const pointer to this nodes parent.
void | setParent (Node *parent)
| Set this node's parent. This is used during construction of an AST and should not be used.

## Static Public Attributes
static constexpr bool | IsSupported
| The list of supported numerical constants.

## Detailed Description

Specialization of Values for strings.

## Member Typedef Documentation

## ◆ ContainerType

using ContainerType

Integers and Floats store their value as ContainerType, which is guaranteed to be at least large enough to represent the maximum possible supported type for the requested precision.

## ◆ Ptr

using Ptr

## ◆ Type

using Type = std::string

## ◆ UniquePtr

using UniquePtr = std::unique_ptr<Value<std::string>>

## Member Enumeration Documentation

## ◆ NodeType

enum NodeType

An enumerated list of node types for all concrete node types. These can be used for faster evaluation of a given concrete node using the virtual function table via Node::nodetype() rather than performing a dynamic_cast/calling Node::isType.

Note
  This is sometimes referred to as "manual RTTI". We use this technique combine with single dispatch due to opting for CRTP on the main visitor and no templated virtual method support in C++. i.e. no way to double dispatch: visit<template T>(Visitor<T>*)
  Abstract (pure-virtual) nodes are not listed here. Node::isType should be used to determine if a node is of a given abstract type.

## Constructor & Destructor Documentation

## ◆ Value() [1/2]

Value | ( | const Type & | value | ) |
| inline

Construct a new Value string from a string.

Parameters

  value | The string to copy onto this Value

## ◆ Value() [2/2]

Value | ( | const Value< Type > & | other | ) |
| inline

Deep copy constructor for a Value string.

Note
  No parent information needs updating as a Value is a "leaf level" node (contains no children)

Parameters

  other | A const reference to another Value string to deep copy

## ◆ ~Value()

~Value | ( |  | ) |
| overridedefault

## Member Function Documentation

## ◆ asContainerType()

ContainerType asContainerType | ( |  | ) | const
| inline

Access the value as its stored type.

Returns
  The value as its stored ContainerType

## ◆ basetype()

const ValueBase * basetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing a node's base class. Note that if this is called explicitly on an instance of ast::Node (the top most base class) a nullptr is returned. This is primarily used by the Visitor to support hierarchical visits.

Returns
  Returns the current node as its base class type.

Reimplemented from Expression.

## ◆ child()

const Node * child | ( | const size_t |  | ) | const
| inlineoverride

Virtual method for accessing child information. Returns a const pointer to a child node at the given index. If the index is out of range, a nullptr is returned.

Note
  This may still return a nullptr even if the given index is valid if the child node has not been created.

Parameters

  index | The child index to query

Returns
  A Pointer to the child node, or a nullptr if none exists.

## ◆ childidx()

int64_t childidx | ( |  | ) | const
| inline

Returns the child index of this node in relation to its parent, or -1 if no valid index is found (usually representing the top most node (i.e. Tree).

Returns
  The child index of this node

## ◆ children()

size_t children | ( |  | ) | const
| inlineoverride

Virtual method for accessing child information. Returns the number of children a given AST node owns.

Returns
  The number of children this node owns.

## ◆ copy()

Value< Type > * copy | ( |  | ) | const
| inlinefinaloverridevirtual

The deep copy method for a Node.

Returns
  A deep copy of the current node and all its children

Implements ValueBase.

## ◆ isType()

bool isType | ( |  | ) | const
| inline

Query whether or not this node is of a specific (derived) type. This method should be used to check if a node is of a particular abstract type. When checking concrete types, it's generally more efficient to check the return value of Node::nodetype().

Template Parameters

  NodeT | The node type to query against.

Returns
  True if this node is of the given type, false otherwise.

## ◆ nodename()

const char * nodename | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Returns
  Returns the node class name

Implements Node.

## ◆ nodetype()

NodeType nodetype | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node type information.

Note
  This method should be used when querying a concrete nodes type.

Returns
  Returns the enumerated node type from the NodeType list

Implements Node.

## ◆ parent()

const Node * parent | ( |  | ) | const
| inline

Access a const pointer to this nodes parent.

Note
  Can be a nullptr if this is the top most node in an AST (usually a Tree)

Returns
  A const pointer to this node's parent node

## ◆ replace()

bool replace | ( | Node * | node | ) |
| inline

In place replacement. Attempts to replace this node at its specific location within its Abstract Syntax Tree. On a successful replacement, this node is destroyed, the provided node is inserted in its place and ownership is transferred to the parent node. No further calls to this node can be made on successful replacements.

Note
  A replacement will fail if this node is the top most node within an AST hierarchy or if the provided node type is not a compatible type for the required abstract storage. For example, if this node is an Attribute being held on a BinaryOperator, only concrete nodes derived from an Expression can be used as a replacement.
  This method will dynamic_cast the provided node to check to see if it's a compatible type.

Parameters

  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, resulting in destruction of this class and ownership transferal of the provided node. False otherwise, where this and the provided node are unchanged.

## ◆ replacechild()

bool replacechild | ( | const size_t | index,
|  | Node * | node )
| inlinevirtual

Virtual method that attempted to replace a child at a given index with a provided node type.

Note
  See Node::replace for a more detailed description

Parameters

  index | The child index where a replacement should be attempted
  node | The node to insert on a successful replacement.

Returns
  True if the replacement was successful, false otherwise

## ◆ setParent()

void setParent | ( | Node * | parent | ) |
| inline

Set this node's parent. This is used during construction of an AST and should not be used.

Parameters

  parent | The parent to set

## ◆ subname()

const char * subname | ( |  | ) | const
| inlineoverridevirtual

Virtual method for accessing node name information.

Returns
  Returns the short node class name

Implements Node.

## ◆ value()

const std::string & value | ( |  | ) | const
| inline

Access the string.

Returns
  A const reference to the string

## Member Data Documentation

## ◆ IsSupported

bool IsSupported
| staticconstexpr

The list of supported numerical constants.

Note
  Strings are specialized and handled separately